<?php

namespace FiloBlu\DynamicCustomOptions\Cron;

class CheckDynamicCustomOptionsRules {

    protected $_helper;
    protected $_dynamicCustomOptionsCollection;
    protected $_loggerCron;

    public function __construct(
    \FiloBlu\DynamicCustomOptions\Model\ResourceModel\DynamicCustomOptions\CollectionFactory $dynamicCustomOptionsCollectionFactory, \FiloBlu\DynamicCustomOptions\Helper\Data $helper, \FiloBlu\DynamicCustomOptions\Model\Logger\LoggerCron $loggerCron
    ) {
        $this->_helper = $helper;
        $this->_dynamicCustomOptionsCollection = $dynamicCustomOptionsCollectionFactory;
        $this->_loggerCron = $loggerCron;
    }

    public function execute() {

        if ($this->_helper->isCronEnabled()) {
            try {

                $this->_loggerCron->info(" #### START CRON CheckDynamicCustomOptionsRules #### ");

                $collection = $this->_dynamicCustomOptionsCollection->create()->addFieldToFilter('is_active', array('eq' => true));
                
                foreach($collection as $dynamicCustomOprionsRule) {
                    $this->_loggerCron->info(" #### START processing ID  -> " . $dynamicCustomOprionsRule->getId() . " #### ");
                    $dynamicCustomOprionsRule->doActions(true);
                    $this->_loggerCron->info(" #### Processed ID  -> " . $dynamicCustomOprionsRule->getId() . " #### ");
                }
                
                $this->_loggerCron->info(" #### END JOB CheckDynamicCustomOptionsRules #### ");
                
            } catch (\Exception $e) {
                $this->_loggerCron->info(" #### ERROR -> " . $e->getMessage() . " #### ");
            }
        }
        else {
            $this->_loggerCron->info(" #### CRON CheckDynamicCustomOptionsRules is not active #### ");
        }
    }

}
